unit Disk;

interface

uses
  SysUtils, WinTypes, WinProcs, Classes;

Type
  PMIDINFO = ^MIDINFO;
  MIDINFO = record
               InfoLevel:  Word;
               SerialNum:  Longint;
               VolLabel:   array[0..10] of Char;
               FileSystem: array [0..7] of Char;
             end;

  TDisk=Class(TComponent)
  Private
    FDisk : String;
    FDiskOk:Boolean;
    FDiskSize:LongInt;
    FDiskFree:LongInt;
    FSNumber:String;
    Procedure DummyLong(Dummy : LongInt);
    Procedure DummyBool(Dummy : Boolean);
    Procedure DummyStr(Dummy : String);
  Protected
    Function CheckDisk(Drive:Integer):Boolean;{Retorna se o disco esta no Drive}
    Function Converte(Drive:String):Integer;{Converte o valor alfabtico em numrico}
    procedure SetDisk(Disk : String); { Acrescentei esta funcao }
    {Adicionado Serial no}
    Function GetSerialNumber (drive: Byte): String;
    Function GetMid (drive: Byte; var mid: MIDINFO): Bool;
    Function GetSetMid (Drive: Byte; MID: PMIDINFO; RealModeAX: Word): Bool;
  Published
{      Procedure Execute; Tirei porque a funcao setdisk engloba ela }
    Property Disk: String read FDisk write SetDisk; {Obtem o disco a ser acessado A, B, C...}
{   Aqui acrescentei uma funcao dummy, pois se nao o usuario pode alterar o valor de DiskOk }
    Property DiskOk: Boolean read FDiskOk write DummyBool; {Retorna se o disco esta no Drive}
    Property DiskSizeKb: LongInt read FDiskSize write DummyLong; {Retorna o Tamanho em Kb do Disco}
    Property DiskFreeKb: LongInt read FDiskFree write DummyLong; {Retorna o espao disponvel em Kb do Disco}
    Property SerialNumber: String read FSNumber write DummyStr; {Retorna o Nmero de Srie em HexaDeciam(String)}
  end;

Procedure Register;
{Function Conv10to16(Number:Real):String;  Nao e necessaria : Substituir por IntToHex;}

implementation

VAR
    R: record     { Real mode call structure }
      di, si, bp, Reserved, bx, dx, cx, ax : Longint;
      Flags, es, ds, fs, gs, ip, sp, ss: Word;
    end;

Procedure Register;
begin
  RegisterComponents('Extra',[TDisk]);
end;

Procedure TDisk.DummyBool(Dummy : Boolean);
begin
end;

Procedure TDisk.DummyLong(Dummy : LongInt);
begin
end;

Procedure TDisk.DummyStr(Dummy : String);
begin
end;

{Esta funcao substitui execute e e executada automaticamente }
Procedure TDisk.SetDisk(Disk : String);
Var SerialNumber: Single;
    Disco: Integer;
    Ok : Boolean;
BEGIN
  FDisk := Disk;
  Disco:=Converte(FDisk);
  If Disco <> 0 then
     Begin
        FDiskOk:=CheckDisk(Disco);
        If FDiskOk then
           begin
             FDiskSize:=Trunc(DiskSize(Disco)/1024);
             FDisKFree:=Trunc(DiskFree(Disco)/1024);
             FSNumber:= GetSerialNumber(Disco);
           end
        Else
           begin
             FDiskSize:=0;
             FDiskFree:=0;
             FSNumber:= '';
           end;
     End
  Else
    Begin
      FDiskOk := False;
      FDiskSize:=0;
      FDiskFree:=0;
      FSNumber:= '';
    End;
END;

Function TDisk.CheckDisk(Drive:Integer):Boolean;
Var
  ErrorMode: Word;
Begin
  {Desabilita os erros crticos}
  ErrorMode:=SetErrorMode(SEM_FailCriticalErrors);
  Try
    {Drive 1 = a, 2 = b, 3 = c ...}
    If DiskSize(Drive) = -1 then
       DiskOk:=False
    Else
       DiskOk:=True;
  finally
    {Restaura o antigo modo de erro}
    SetErrorMode(ErrorMode);
  end;
end;

Function TDisk.Converte(Drive:String):Integer;
var Disco: Char;
Begin
   Disco := Drive[1];
  {Transforma em maiuscula}
  if Disco in ['a'..'z'] Then
     Dec(Disco, $20); {Subtrai 32 caractrers para transformar para
maiuscula}
  {Verifica se  realmente uma letra}
  if not (Disco in ['A'..'Z']) then
     Begin
       raise EConvertError.Create('ID de Drive invlido.');
       Converte := 0;
     End
   Else
     Converte := (Ord(Disco) - $40); {Subtrai 64 caractrers para transformar
para obter posicao relativa}
End;
(*
Function Conv10to16(Number:Real):String;
{Transforma decimal em Hexa, para nmeros reais.}
Var Numeros: Array[0..16] of String[1];
    HexNumero: String;
    i: Integer;
    Dividendo, Quociente: Real;
    Divisor, Resto: Integer;
Begin
For i:=0 to 9 do
    Numeros[i]:=inttostr(i);
Numeros[10]:='A';
Numeros[11]:='B';
Numeros[12]:='C';
Numeros[13]:='D';
Numeros[14]:='E';
Numeros[15]:='F';
Dividendo:=Number;
Quociente:=17;
HexNumero:= '';
If Number<16 then
   Quociente:=Number;
While Quociente>=16 do
   begin
      Resto:= (Trunc(Dividendo) Mod 16);
      HexNumero := Numeros[Resto]+HexNumero;
      Quociente := Trunc(Dividendo/16);
      Dividendo := Quociente;
   end;
   HexNumero := Numeros[Trunc(Quociente)]+HexNumero;
   Conv10to16 := HexNumero;
End;
*)
{  Name:    GetSetMid                                                 }
{  Purpose: Low level code to get a MIDINFO data structure for the    }
{    specified drive.                                                 }
function TDisk.GetSetMid (Drive: Byte; MID: PMIDINFO; RealModeAX: Word):
Bool;
var
    Error: Byte;
begin
    { Assume everything ok }
    Error := 0;
    GetSetMid := True;

    R.ax := RealModeAX;
    R.bx := Drive;
    R.ds := HiWord (Longint (MID));
    R.dx := LoWord (Longint (MID));

    asm
        mov bx, 0021h     { set flags to $00, Real mode interrupt $21 }
        xor cx, cx        { copy 0 words from protected mode stack }
        mov ax, seg R
        mov es, ax        { selector of real mode call structure }
        mov di, offset R  { offset of real mode call structure }
        mov ax, 0300h     { DPMI simulate real mode interrupt }
        int 31h           { do the business }
        jnc @@1           { branch if no error }
        inc Error
    @@1:
    end;

    if Error = 1 then GetSetMid := False;
end;

{    Name:    GetMid                                                   }
{    Purpose: Get the MIDINFO record for a specified drive.            }
{             Uses GetSetMid.  Returns TRUE if successful.             }
function TDisk.GetMid (drive: Byte; var mid: MIDINFO): Bool;
var
    p: LongInt;
begin
    { Assume failure }
    GetMid := False;

    { Allocate a MIDINFO data structure in DOS address-space }
    p := GlobalDOSAlloc (sizeof (MIDINFO));

    if GetSetMid (drive, Ptr (HiWord (p), 0), $6900) then
    begin
        mid := PMIDINFO (Ptr (LoWord (p), 0))^;
        GetMid := True;
    end;

    GlobalDOSFree (LoWord (p));
end;

{    Name:    GetSerialNumber                                          }
{    Purpose: Get the serial number for a specified drive.             }
{       If an error occurs, then 0 is returned as the serial number.   }
function TDisk.GetSerialNumber (drive: Byte): String;
var
    NumeroSerie:LongInt;
    mid: MIDINFO;
begin
    {if GetMid (drive, mid) then GetSerialNumber := mid.SerialNum
    else GetSerialNumber := 0;}
    if GetMid (drive, mid) then NumeroSerie := mid.SerialNum
    else NumeroSerie := 0;
    Result := IntToHex(NumeroSerie,8);
    Result := Copy(Result,1,4)+'-'+Copy(Result,5,4)
end;

End.